#include "cs.h"				/*		MEMALLOC.C	*/

float  sstrcod = SSTRCOD;  /* global here so reachable by all standalones */

#ifdef CWIN
static void* all[1024];
static int ap=0;
extern void __cdecl DisplayMsg(char *, ...);

void all_free(void)
{
/*   DisplayMsg("%d blocks to free", ap); */
    while (--ap>=0) {
/*        DisplayMsg("freeing %p", all[ap]); */
        free(all[ap]);
    }
    return;
}
#endif

static memdie(void)
{
  err_printf("memory allocate failure\n");
  exit(1);
}

 char *
mcalloc(long nbytes)		/* allocate new memory space, cleared to 0 */
{
	register char *p;

	if ((p = calloc((size_t)1,(size_t)nbytes)) == NULL)
		memdie();
#ifdef CWIN
        all[ap++] = p;
	if (ap >1023) err_printf( "Too many allocs\n"), exit(1);
#endif
	return(p);
}

 char *
mmalloc(long nbytes)	     /* allocate new memory space, NOT cleared to 0 */
{
	register char *p;

	if ((p = malloc((size_t)nbytes)) == NULL)
		memdie();
#ifdef CWIN
        all[ap++] = p;
	if (ap >1023) err_printf( "Too many allocs\n"), exit(1);
#endif
	return(p);
}

 void *
mrealloc(void *old, long nbytes)		/* Packaged realloc */
{
    void *p;

    if ((p = realloc(old, (size_t)nbytes)) == NULL)
	memdie();
#ifdef CWIN
    all[ap++] = p;
    if (ap >1023) err_printf( "Too many allocs\n"), exit(1);
#endif
    return(p);
}

